/***************************************************************************/
/*                           E D I T P A T H . E                           */
/*                                                                         */
/* This file contains definitions to save the edit path from session to    */
/* session, so once you change the EPM directory it stays that way!  To    */
/* use these definitions, add the following lines to MYSTUFF.E:            */
/*                                                                         */
/*   Compile If EPM                                                        */
/*     include 'EDITPATH.E'                                                */
/*   Compile Endif                                                         */
/*                                                                         */
/* Then re-compile EPM using ETPM.                                         */
/*                                                                         */
/* Written by B. Thompson 91/09/17                                         */
/*                                                                         */
/***************************************************************************/

/***************************************************************************/
/* Set up a variable for the INI entry which holds our data                */
/***************************************************************************/

Const
  INI_EDITPATH      = 'EDITPATH'

/***************************************************************************/
/* At EPM startup time, change to the last saved directory, or leave the   */
/* directory the same if we haven't yet saved any data                     */
/***************************************************************************/

Definit
  newpath = checkini(0, INI_EDITPATH, directory())
  'CD' newpath

/***************************************************************************/
/* We're loading a new file - save the current EPM directory in EPM.INI.   */
/***************************************************************************/

Defload
  Call setini(INI_EDITPATH, directory())

